/*
 * libcfg+ - precise command line & config file parsing library
 *
 * cfgfile.h - config file parsing header file
 * ____________________________________________________________
 *
 * Developed by Ondrej Jombik <nepto@pobox.sk>
 * Copyright (c) 2001-2002 Platon SDG, http://www.platon.sk/
 * All rights reserved.
 *
 * See README file for more information about this software.
 * See COPYING file for license information.
 *
 * Download the latest version from
 * http://www.platon.sk/projects/libcfg+/
 */

/* $Id: cfgfile.h,v 1.5 2002/04/21 10:08:40 jombik9 Exp $ */

/**
 * @file	cfgfile.h
 * @brief	config file parsing header file
 * @author	Ondrej Jombik <nepto@pobox.sk>
 * @version	\$Id: cfgfile.h,v 1.5 2002/04/21 10:08:40 jombik9 Exp $
 * @date	2001-2002
 */

#ifndef _PLATON_CFG_CFGFILE_H
#define _PLATON_CFG_CFGFILE_H

/**
 * Parse next config file option(s) and return its value (if non-zero)
 * or error code.
 *
 * @param con	initialized config file context
 * @return		next option val, code of error (CFG_ERR_*)
 *				or CFG_OK on end
 * @see			cfg_error
 * @see			cfg_context
 */
int cfg_cfgfile_get_next_opt(const CFG_CONTEXT con);

#endif /* _PLATON_CFG_CFGFILE_H */

