#ifndef _PLATON_STR_STRDYN_H
#define _PLATON_STR_STRDYN_H

/*
 * TODO list:
 *
 * 1. Functions for removing from array.
 * 2. Optimalizations (in strdyn_explode_ar() and similar).
 */

#define strdyn_count(ar) strdyn_get_size(ar)

#define strdyn_duplicate(ar) strdyn_create_ar(ar)
#define strdyn_safe_duplicate(ar) strdyn_safe_create_ar(ar)
#define strdyn_remove(ar, s) strdyn_remove_str(ar, s)

#define strdyn_intersect(ar1, ar2) strdyn_conjunct(ar1, ar2)
#define strdyn_join(ar1, ar2) strdyn_consolide(ar1, ar2)
#define strdyn_union(ar1, ar2) strdyn_consolide(ar1, ar2)

#define strdyn_explode(str, sep) strdyn_explode_str(str, sep)
#define strdyn_explode2(str, sep) strdyn_explode2_str(str, sep)
#define strdyn_implode(str, sep) strdyn_implode_str(str, sep)
#define strdyn_implode2(str, sep) strdyn_implode2_str(str, sep)

#define strdyn_cmp(ar, s) strdyn_compare(ar, s)
#define strdyn_casecmp(ar, s) strdyn_casecompare(ar, s)
#define strdyn_str(s, ar) strdyn_str2(s, ar, NULL)

#ifdef __cplusplus
extern "C" {
#endif

void strdyn_free(char **ar);
void strdyn_safe_free(char **ar);
int strdyn_get_size(char **ar);
char **strdyn_create(void);
char **strdyn_create_va(char *s1, ...);
char **strdyn_create_ar(char **ar);
char **strdyn_safe_create_ar(char **ar);
char **strdyn_add(char **ar, const char *s);
char **strdyn_add_va(char **ar, ...);
char **strdyn_add_ar(char **ar, char * const *s_ar);
char **strdyn_remove_idx(char **ar, int idx);
char **strdyn_remove_str(char **ar, char *s);
char **strdyn_remove_str_all(char **ar, char *s);
char **strdyn_remove_empty(char **ar);
char **strdyn_explode_chr(char *str, int sep);
char **strdyn_explode2_chr(char *str, int sep);
char **strdyn_explode_str(char *str, char *sep);
char **strdyn_explode2_str(char *str, char *sep);
char **strdyn_explode_ar(char *str, char **sep);
char **strdyn_explode2_ar(char *str, char **sep);
char *strdyn_implode_chr(char **ar, int sep);
char *strdyn_implode2_chr(char **ar, int sep);
char *strdyn_implode_str(char **ar, char *sep);
char *strdyn_implode2_str(char **ar, char *str);
char **strdyn_conjunct(char **ar1, char **ar2);
char **strdyn_consolide(char **ar1, char **ar2);
int strdyn_search(char **ar, char *s);
int strdyn_casesearch(char **ar, char *s);
int strdyn_compare(char **ar, char *s);
int strdyn_casecompare(char **ar, char *s);
int strdyn_compare_all(char **ar, char *s);
char *strdyn_str2(char *s, char **ar, int *idx);

#ifdef __cplusplus
}
#endif

#endif /* _PLATON_STR_STRDYN_H */

